package de.oaa.xxx.games.bdsm.aufgaben;

import de.oaa.xxx.games.bdsm.GeschlechtEnum;
import de.oaa.xxx.games.bdsm.Mitspieler;
import de.oaa.xxx.games.bdsm.Werkzeug;
import lombok.Getter;
import lombok.Setter;

import java.util.List;
import java.util.UUID;

@Getter
@Setter
public class Finisher {

    private UUID finisherId;
    private String kurzText;
    private String text;
    private GeschlechtEnum geschlecht;
    private List<Werkzeug> benoetigtAktiv;
    private List<Werkzeug> benoetigtPassiv;

    @Override
    public String toString() {
        return "Finisher[id=" + finisherId + ", kurzText=" + kurzText + ", geschlecht=" + geschlecht + "]";
    }
    
    public boolean isAufgabePassend(Mitspieler aktiv, Mitspieler passiv) {      
        if (benoetigtPassiv != null) {
            for (Werkzeug werkzeug : benoetigtPassiv) {
                if (!passiv.isVerfuegbar(werkzeug)) {
                    return false;
                }
            }
        }
        if (benoetigtAktiv == null || benoetigtAktiv.isEmpty()) {
            return true;
        } else {
            for (Werkzeug werkzeug : benoetigtAktiv) {
                if (aktiv.isVerfuegbar(werkzeug)) {
                    return true;
                }
            }
            return false;
        }
    }
}
